

void update_unison() {
int16_t vfreq;
uint8_t vrange;

	// test si mode UNISON actif
	if (ModeMidi!=UNISON )
		return;
	// test si compteur unison en depassement
	if (unison_cnt++ >CALC_UNISON_CNT) {
		// si depassement test si une note est jouee
		if (MidinoteNumber[0] == 0)
			return;							// si aucune note on sort
		unison_cnt=0;						// RAZ counter unison
		 if (MidinoteNumber[0] >= 48 && MidinoteNumber[0]<64)
			 vunison=random(6)-3;
		 if (MidinoteNumber[0] >= 64 && MidinoteNumber[0]<76)
			 vunison=random(4)-2;
		if (MidinoteNumber[0] >= 76)
			vunison=random(2)-1;
		 // if (vchannel++ >2)
			 // vchannel=0;
			
		vchannel=random(3);					// Calcul du canal (de 0 a 2)
		RefreshFrequency(vchannel);
	}
}

//--------------------------
// Selection du mode de jeu
// lecture de l'interrupteur
//--------------------------
void update_switch_mode() {
int m,i;
	m=analogRead(PIN_MODE);
	if (m> 900) {
		ModeMidi=MONO;
	}
	else if (m>450) {
		ModeMidi=POLY;
	}
	else {
		ModeMidi=UNISON;
	}
	// Si changement de jeu par rapport a celui en cours
	// On RAZ les parametres de jeu
	if (ModeMidi!=LastMode) {
		LastMode=ModeMidi;
		for (i=0;i<4;i++) {
			MidinotePlay[i]=0;
			MidinoteVelocity[i]=0;
			MidinoteNumber[i]=0;
			MidinoteBend[i]=0;
		}
		SoundOffSN76489(0);
	}
}

//----------------------------------------------------
// Update du range SN76489
// Lit le potard de range
// Modifie la vitesse d'horloge generee par l'arduino
// pour piloter le SN76489
//----------------------------------------------------
void update_pot_range() {
int m,i;
	m=analogRead(PIN_RANGE);
	CALC_UNISON_CNT=3000;
	// Si potard 75-100%
	// horloge a 4mhz
	if (m > 768) {
		OCR1A=1;
		return;
	}
	// Si potard 50-75%
	// horloge a 2 mhz
	if (m > 512 && m <= 768) {
		OCR1A=3;
		return;
	}
	// Si potard 25-50%
	// horloge a 1 mhz
	if (m > 256 && m <=512) {
		OCR1A=7;
		return;
	}
	// Le potard est sur les premiers 25%
	// Horloge a 500Khz
	CALC_UNISON_CNT=500;
	OCR1A=15;
}
//----------------------------------------------------
// Update lecture release
// Lit le potard de release
//----------------------------------------------------
void update_pot_release() {
	v_release=analogRead(PIN_RELEASE) >> 2;
	
}

//----------------------------------------------------
// Update lecture parametre lfofreq
// Lit le potard de reglage frequence LFO
//----------------------------------------------------
void update_pot_lfospeed() {
	lfofreq=analogRead(PIN_LFOSPEED)>>2;
}

//----------------------------------------------------
// Update lecture parametre user2
// Lit le potard de parametre user2
//----------------------------------------------------
void update_pot_lfodepth() {
	lfodepth=analogRead(PIN_LFODEPTH)>>2;
}

//-----------------------------------------
// Lecture des boutons
// et des potentiometres
// Chaque element est lu sequentiellement
// pour ne pas surcharger inutilement
//-----------------------------------------
void read_buttons_and_pots() {
	if (read_cnt++ > CALC_READ_POT) {
		read_cnt=0;
		if (items_cnt++ > MAX_ITEMS_READ)
			items_cnt=0;
		switch(items_cnt) {
			case 0:
				update_pot_range();		// MAJ clock SN76489
				break;
			case 1:
				update_pot_release();		// MAJ valeur de release de l'enveloppe
				break;
			case 2:
				update_switch_mode();	// MAJ selection de jeu
				break;
			case 3:
				update_pot_lfospeed();		// MAJ frequence LFO
				break;
			case 4:
				update_pot_lfodepth();		// MAJ parametre user
				break;
		}
	}
}

//---------------------------------------------------
// MAJ de l'enveloppe
// Les amplitudes des oscillateurs seront rafraichies
// si besoin
//---------------------------------------------------
void update_enveloppe() {
int i;
float tempVelo;
	if (millis() < nexttime) 		// Update necessaire
		return;						// Non on sort
	nexttime=millis()+MULT_RELEASE;	// On remet a jour pour la prochaine fois
	// On balaie ensuite les 3 canaux
	for (i=0; i<3; i++ ) {
		if (stateRelease[i]==RELEASE_IN_PROGRESS ) {					// si release en cours pour le canaux selectionne
			v_velocityInit[i]=v_velocityInit[i]-v_decrement[i];			// On decremente sa velocite
			if (v_velocityInit[i] > 0) {								// Si velocite positive
				UpdateAmplitude(i,(uint8_t)v_velocityInit[i],0);		// on l'ecrit dans le chip
			}
			else {														// Sinon vi velocite nulle ou negative
				v_velocityInit[i]=0;									// on RAZ velocite float
				MidinoteVelocity[i]=0;									// RAZ velocite normale
				stateRelease[i]=RELEASE_NO_SOUND;						// On passe a etat NOSOUND pour ce channel
				UpdateAmplitude(i,0,0);									// On met l'amplitude a zero
			}
		}
	}
}


//----------------------------
// Mise a jour de letat du LFO
//----------------------------
void update_lfo()
{
int i;
	// Test si fin de lfo via modwheel
	// On refresh la frequence
	for (i=0;i<3;i++) {
		if (lfo[i]==9) {
			lfo[i]=0;
			vlfo[i]=0;
			RefreshFrequency(i);
		}
	}
	// Si depth au minimum
	// ou frequence LFO au minimum
	if (!lfodepth || !lfofreq) {
		lfoval=0;
		vlfo[0]=0;
		vlfo[1]=0;
		vlfo[2]=0;
		return;
	}
	// Calcule de la gigue
	lfodelta = (lfofreq) ? (lfodepth*256U) / lfofreq : 0;
	
	// Verifie si le lfo doit être mise a jour
	// si le temps "RefreshRateLfo" est depasse
	 if (millis() < lastlfocnt+RefreshRateLfo) 
		  return;
	lastlfocnt=millis();

	
	lfoval = (lfotimer*lfodelta) >> 8;			// On reduit la valeur du lfo à 8 bit
	if (lfotimer >= lfofreq/2)					// la profondeur totale est utilisee pour la montee et la descente cumulee
		lfoval = lfodepth - lfoval;				// donc les valeurs de lfo seront egale à la moitie de la profondeur

	lfotimer++;									// On incremente le timer
	if (lfotimer >= lfofreq)					// si il a atteint la valeur maxi fixee par lfospeed
		lfotimer = 0;							// on le remet a zero
	// On test le mode midi en cours
	// Mono, Poly ou Unison
	switch (ModeMidi) {
		// Monophonique
		// 3 canaux midi possible
		case MONO :
			for (i=0;i<3;i++) {							// On effectue l'operation pour les 2 canaux musique
				if (lfo[i]) {							// si lfo actif sur canal en cours 
					vlfo[i]=lfoval-(lfodepth/4);		// on update la valeur du lfo et on transforme en symetrique
					RefreshFrequency(i);				// on rafraichit le canal
				}
			}
			break;
		// Mode Unison ou Polyphonique
		// 1 seul canal possible (le 1 en midi, 0 au sens du SN76489)
		case UNISON:
		case POLY:
			if (lfo[0]) {								// Si lfo du canal 0 actif et mode Polyphonique
				for (i=0;i<3;i++) {						// On effectue l'operation pour les 2 canaux musique
					vlfo[i]=lfoval-(lfodepth/4);		// on update la valeur du lfo et on transforme en symetrique
					RefreshFrequency(i);				// on rafraichit le canal
				}
			}
			break;
	}
}
